function addSelOption(obj, value, text) {
    obj.length++;
    obj.options[obj.length - 1].value = value;
    obj.options[obj.length - 1].text = text;
}


function createSelection(obj, varray, tarray) {
    obj.length = 0;
    for (var idx = 0; idx < varray.length; idx++) {
        addSelOption(obj, varray[idx], tarray[idx]);
    }
}


function getRadioValue(obj) {
    for (var idx = 0; idx < obj.length; idx++) {
        if (true == obj[idx].checked) {
            return idx;
        }
    }

    return -1;
}


function createCamNumSelection(num) {
    var v_camNums = new Array();
    var t_camNums = new Array();

    for (var idx = 0; idx < num; idx++) {
        v_camNums[idx] = idx + 1;
        t_camNums[idx] = String(v_camNums[idx]);
    }

    createSelection(form1.elements['u_camNum'], v_camNums, t_camNums);
    form1.u_camNum.value = num;
}


function createRecSndCamNumSelection(sndnum, num) {
    var v_camNums = new Array();
    var t_camNums = new Array();

    var nowrecSndCamNum = form1.u_recSndCamNum.value;
    if ('' == nowrecSndCamNum) {
        nowrecSndCamNum = 0;
    }

    for (var idx = 0; idx <= sndnum; idx++) {
        if (idx > num) {
            break;
        }
        v_camNums[idx] = idx;
        t_camNums[idx] = String(v_camNums[idx]);
    }

    createSelection(form1.elements['u_recSndCamNum'], v_camNums, t_camNums);

    if (nowrecSndCamNum > (idx - 1)) {
        form1.u_recSndCamNum.value = v_camNums[0];
    } else {
        form1.u_recSndCamNum.value = nowrecSndCamNum;
    }
}


function createHddCapacitySelection(values) {
    var v_hddCapa = new Array();
    var t_hddCapa = new Array();

    for (var idx = 0; idx < values.length; idx++) {
        v_hddCapa[idx] = values[idx];
        t_hddCapa[idx] = String(values[idx]);
    }

    createSelection(form1.elements['u_hddCapa'], v_hddCapa, t_hddCapa);
    form1.u_hddCapa.value = v_hddCapa[0];
}


function createHourOfDaySelection(obj) {
    var v_nums = new Array();
    var t_nums = new Array();

    for (var idx = 0; idx < 24; idx++) {
        v_nums[idx] = idx + 1;
        t_nums[idx] = String(v_nums[idx]);
    }

    createSelection(obj, v_nums, t_nums);
    obj.value = 24;
}


function createRaidSelection() {
    var v_nums = new Array();
    var t_nums = new Array();

    for (var idx = 0; idx < s_input_p09_List.length; idx++) {
        v_nums[idx] = idx;
        t_nums[idx] = s_input_p09_List[idx];
    }

    createSelection(form1.u_hddProtect, v_nums, t_nums);
    form1.u_hddProtect.value = 0;
}


function ConvHdd_RaidToPhysical(num) {
    var raid = form1.u_hddProtect.value;
    var retval = 0;

    if (0 == raid) {
        retval = num;
    } else if (1 == raid) {
        retval = num + 1;
        if (retval < 3) {
            retval = 3;
        }
    } else {
        retval = num + 2;
        if (retval < 4) {
            retval = 4;
        }
    }

    if (0 >= num) {
        retval = 0;
    }

    return retval;
}


function ConvHdd_PhysicalToRaid(num) {
    var raid = form1.u_hddProtect.value;
    var retval = 0;

    if (0 == raid) {
        retval = num;
    } else if (1 == raid) {
        if (num < 3) {
            num = 3;
        }
        retval = num - 1;
    } else {
        if (num < 4) {
            num = 4;
        }
        retval = num - 2;
    }

    if (0 >= num) {
        retval = 0;
    }

    return retval;
}

(function() {
    var temp = document.createElement('div');
    if (temp.innerText == undefined) {
        Object.defineProperty(HTMLElement.prototype, 'innerText', {
            get: function() { return this.textContent },
            set: function(v) { this.textContent = v; }
        });
    }
})();


function numOnly2(nKeyCode) {

    if (nKeyCode == 46 || nKeyCode == 37 || nKeyCode == 39) {
        return true;
    }

    if ((96 <= nKeyCode) && (nKeyCode <= 105)) {
        return true;
    }

    var m = String.fromCharCode(nKeyCode);
    if ('0123456789\d\b\r\t'.indexOf(m, 0) < 0) {
         return false;
    }

    return true;

}

function getBrowserVersion() {
    return window.opera ?
        (opera.version().replace(/\d$/, '') - 0) :
        parseFloat((/(?:IE |fox\/|ome\/|ion\/)(\d+\.\d)/.
            exec(navigator.userAgent) || [, 0])[1]);
}


function Outputmsg(msg, level) {
    if (getBrowserVersion() == 6) {
        alert(msg);
    } else {
        if (level == 1) {
            jInfomsg(msg, app_name);
        }
        else {
            jAlert(msg, app_name);
        }
    }
}

function regNewCamTo360table(mode, camid) {

    if (is360dev(camid) == true && is360linked(camid) == true) { 
        var nTarget = get360linkID(camid);
        toggle360link(get360linkID(nTarget), nTarget);
    }
    switch (mode) {
        case mic1_omni:
            reg360mic(camid);               
            break;
        case ipro4_fhd_om:
        case ipro4a_om:
        case ipro4b_om:
        case ipro6_fe_s_om:
        case ipro6_p_s_om:
        case ipro6_2m_s_om:
            reg360cam(camid);               
            break;
        default:
            clear360dev(camid);             
            break;
    }
}

function toggle360link(in1, in2) {
    a = Math.abs(in1);   
    b = Math.abs(in2);   
    var c = gArr360Info[a];
    gArr360Info[a] = - gArr360Info[b];
    gArr360Info[b] = - c;
}

function is360cam(indata) {
    a = Math.abs(indata);   
    return ((gArr360Info[a] > 0) ? true : false);
}

function is360mic(indata) {
    a = Math.abs(indata);   
    return ((gArr360Info[a] < 0) ? true : false);
}

function is360dev(indata) {
    a = Math.abs(indata);   
    return ((gArr360Info[a] != 0) ? true : false);
}

function is360linked(indata) {
    a = Math.abs(indata);   
    return ((Math.abs(gArr360Info[a]) != a) ? true : false);
}

function reg360cam(indata) {
    camid = Math.abs(indata);
    gArr360Info[camid] = camid;
}

function reg360mic(indata) {
    camid = Math.abs(indata);
    gArr360Info[camid] = - camid;
}

function clear360dev(indata) {
    camid = Math.abs(indata);
    gArr360Info[camid] = 0;
}

function get360linkID(indata) {
    camid = Math.abs(indata);
    return (gArr360Info[camid]);
}

function force360audioOn(indata) {
    camid = Math.abs(indata);
    var setAudio = 'cam' + camid + 'audio';
    var setAudioID = document.getElementById(setAudio);
    setSelectionSelected(setAudioID, p_on); 
}

function force360audioOff(indata) {
    camid = Math.abs(indata);
    var clrAudio = 'cam' + camid + 'audio';
    var clrAudioID = document.getElementById(clrAudio);
    setSelectionSelected(clrAudioID, p_off); 
}
